/*
 *  AdORB
 *  Copyright (C) 2006 Victor Ananiev
 *
 *  This file is part of IDLBrowser.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#import <Cocoa/Cocoa.h>

@class IDLItem;
@class IDLDefinition;

@interface IDLRunController : NSObject
{
    IBOutlet NSWindow *window;
    IBOutlet NSScrollView *scrollView;
	IDLItem* _item;
	NSString* _status;
	id _connection;
	IDLDefinitionScope* _rootScope;
	struct {
		unsigned sending:1;
		unsigned editInvalid:1;
		unsigned simulatorAvailable:1;
		unsigned usesSimulator:1;
		unsigned:28;
	} _flags;
	
}

- initWithDefinition:(IDLDefinition*)def;
- initWithIDLItem:(IDLItem*)item;
- window;
- (void) setConnection:conn;
- connection;
- (void) removeSelectedItem:sender;
- (void) insertNewItem:sender;
- (IDLDefinitionScope*)rootScope;
- (void) setRootScope:(IDLDefinitionScope*)scope;
- (void) setScope;
- (void) endEditing;
- (BOOL) usesSimulator;
- (void) setSimulatorAvailable:(BOOL)flag;
@end
