/*
 *  AdORB
 *  Copyright (C) 2006 Victor Ananiev
 *
 *  This file is part of IDLBrowser.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#import "TypesBrowser.h"

@implementation TypesBrowser

static NSImage* _barImage = nil;
static NSSize _barSize = {15, 14};

+ (void) initialize
{
	_barImage = [NSImage imageNamed:@"bar15"];
	_barSize.width = [_barImage size].width;
}

- (float) titleHeight
{
	return _barSize.height;
}

- (void)drawTitleOfColumn:(int)column inRect:(NSRect)rect
{
	NSRect r = rect;
	r.origin.y -= 1.0;
	float y = r.origin.y;
	r.size.height = _barSize.height;
	r.size.width = _barSize.width;
	while(r.origin.x < NSMaxX(rect)){
		if(NSMaxX(r) <= NSMaxX(rect))
			[_barImage compositeToPoint:NSMakePoint(NSMinX(r), y) operation:NSCompositeSourceOver];
		else
			[_barImage compositeToPoint:NSMakePoint(NSMinX(r), y) 
					fromRect:NSMakeRect(0,0,NSMaxX(rect) - NSMinX(r), _barSize.height)
					operation:NSCompositeSourceOver];
		r.origin.x += _barSize.width;
	}
	if(column <= [self lastColumn]){
		NSDictionary* attrs = [NSDictionary dictionaryWithObjectsAndKeys:
			[NSFont boldSystemFontOfSize:12.0], NSFontAttributeName, nil];
		NSString* title = [self titleOfColumn:column];
		r.origin.x = rect.origin.x;
		r.size.width = rect.size.width;
		r.size.height = [title sizeWithAttributes:attrs].height;
		[title drawInRect:r withAttributes:attrs];
	}
}

@end
