
/*
 *  AdORB
 *  Copyright (C) 2006 Victor Ananiev
 *
 *  This file is part of ADORB.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#import <Foundation/Foundation.h>
#import "ORB.h"

@class IDLDefinitionScope, IDLDefinition, IDLInterface, CORBAObject, IDLParser;

@interface ORB(Private)
+ (NSString*) nameFromTypeId:(NSString*)typeId;

+ (NSData*) parseIORString:(NSString*)iorString;
+ (NSString*) iorWithData:(NSData*)data;
+ objectForObjectID:(NSData*)objKey;

- (IDLDefinitionScope*) rootScope;

// Raises CORBADuplicateKey exception
+ (void) registerObject:(CORBAObject*)object;

@end

#import "ORBNotificationCenter.h"

@interface ORBNotificationCenter(Private)

- (NSException*) postWillSendRequest:anObject userInfo:(NSDictionary*)userInfo flowStack:(NSMutableArray*)flowStack;
- (NSException*) postDidReceiveReply:anObject userInfo:(NSDictionary*)userInfo flowStack:(NSMutableArray*)flowStack;
- (NSException*) postDidReceiveException:anObject userInfo:(NSDictionary*)userInfo flowStack:(NSMutableArray*)flowStack;
- (NSException*) postDidReceiveOther:anObject userInfo:(NSDictionary*)userInfo flowStack:(NSMutableArray*)flowStack;

- (NSException*) postDidReceiveRequestContext:anObject userInfo:(NSDictionary*)userInfo flowStack:(NSMutableArray*)flowStack;
- (NSException*) postDidReceiveRequest:anObject userInfo:(NSDictionary*)userInfo flowStack:(NSMutableArray*)flowStack;

- (NSException*) postWillSendResponse:anObject userInfo:(NSDictionary*)userInfo flowStack:(NSMutableArray*)flowStack;
- (NSException*) postWillSendException:anObject userInfo:(NSDictionary*)userInfo flowStack:(NSMutableArray*)flowStack;
- (NSException*) postWillSendOther:anObject userInfo:(NSDictionary*)userInfo flowStack:(NSMutableArray*)flowStack;

@end
